/* extract_tags.h
 *
 * (C) 2000 empeg ltd, http://www.empeg.com
 *
 * This software is licensed under the GNU General Public Licence (see file
 * COPYING), unless you possess an alternative written licence from empeg ltd.
 *
 * $Header: /home/cvs/symo/empeg/extract_tags.h,v 1.1 2001/08/24 20:03:51 peter Exp $
 *
 * Authors:
 *   Roger Lipscombe <roger@empeg.com>
 */

#ifndef EXTRACTTAGS_H
#define EXTRACTTAGS_H 1

struct ExtractTagsObserver;
class SeekableStream;

class ExtractTags
{
    ExtractTagsObserver *m_pObserver;
    int m_dataOffset;

public:
    ExtractTags(ExtractTagsObserver *pObserver)
	: m_pObserver(pObserver)
    {
    }

    /** (Attempt to) open the file and extract the information. The second
     * parameter points to the file extension (e.g. ".mp3"), or pass NULL
     * to use the extension on the 'path' parameter.
     */
    STATUS Extract(const char *path, const char *extension=NULL);

private:
    STATUS IdentifyMP3(const char *path);
    STATUS ExtractMP3Tags(const char *path);
    STATUS ExtractFrameInfo(const char *path);
    STATUS IdentifyWMA(const char *path);
    STATUS IdentifyWAV(const char *path);
    STATUS IdentifyWAVStream(SeekableStream *stream);
};

struct ExtractTagsObserver
{
    virtual void OnExtractTag(const char *tagName, const char *tagValue) = 0;

    // TODO: Deprecate this method...
    virtual void OnExtractTag(const char *tagName, int tagValue) = 0;

    virtual ~ExtractTagsObserver() {}
};

#endif /* EXTRACTTAGS_H */
